from linked_list import LinkedList

# Wszystkie operacje stosowe/kolejkowe mają stałą złożoność
# (używając listy łączonej)
# praktyczna implementacja w bibliotece Pythona:
# from queue import deque # double-ended queue

# alternatywna implementacja (okrojonego) stosu
class StackLL:
    def __init__(self):
        self.items = LinkedList()

    def is_empty(self):
        return self.items.is_empty()

    def push(self, item):
        self.items.push_front(item)

    def pop(self):
        return self.items.pop_front()


# alternatywna implementacja (okrojonej) kolejki
class QueueLL:
    def __init__(self):
        self.items = LinkedList()

    def is_empty(self):
        return self.items.is_empty()

    def enqueue(self, item):
        self.items.push_back(item)

    def dequeue(self):
        return self.items.pop_front()


if __name__ == "__main__":
    s = StackLL()
    print(s.is_empty())
    s.push(1)
    s.push(2)
    s.push(3)
    print(s.is_empty())
